
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Partage_eaux &#8212; Documentation Segmentation Image 4.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Partage_eaux</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/03/2019</span>
<span class="c1"># Classe Partage des eaux Version 0.1</span>
<span class="c1">#####################################</span>

<span class="c1">### IMPORTATION DES BIBLIOTHEQUES</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="c1">### IMPORTATION DES CLASSES</span>
<span class="kn">from</span> <span class="nn">Image</span> <span class="k">import</span> <span class="n">Image</span>
<span class="kn">from</span> <span class="nn">Pixel</span> <span class="k">import</span> <span class="n">Pixel</span>
<span class="kn">from</span> <span class="nn">Gradient</span> <span class="k">import</span> <span class="n">Gradient</span>
<span class="kn">from</span> <span class="nn">ListeTrieePixel</span> <span class="k">import</span> <span class="n">ListeTrieePixel</span>



<span class="c1">### DEBUT de la classe Partage_eaux</span>

<div class="viewcode-block" id="Partage_eaux"><a class="viewcode-back" href="../tec_doc.html#Partage_eaux.Partage_eaux">[docs]</a><span class="k">class</span> <span class="nc">Partage_eaux</span><span class="p">:</span>
    
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    </span>
<span class="sd">    **AUTRES CLASSES IMPORTEES**</span>
<span class="sd">    </span>
<span class="sd">    * math</span>
<span class="sd">    * numpy</span>
<span class="sd">    * Image</span>
<span class="sd">    * Pixel</span>
<span class="sd">    * Gradient</span>
<span class="sd">    * ListeTrieePixel</span>
<span class="sd">    </span>
<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Partage_eaux.__init__"><a class="viewcode-back" href="../tec_doc.html#Partage_eaux.Partage_eaux.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">image</span><span class="p">,</span> <span class="n">L_Obj</span><span class="p">,</span> <span class="n">L_Bkg</span><span class="p">,</span> <span class="n">gamma</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Constructeur d&#39;un objet Partage_eaux à partir d&#39;une image d&#39;une liste de pixels de l&#39;objet et d&#39;une liste de pixels de l&#39;arrière plan et de gamma, un élément structurant. </span>

<span class="sd">        :param self: Objet Partage_eaux </span>
<span class="sd">        :type self: Partage_eaux</span>
<span class="sd">        </span>
<span class="sd">        :param image: objet Image est un tableau numpy d&#39;une image codée sur une couche en niveaux de gris</span>
<span class="sd">        :type image: Image</span>
<span class="sd">        </span>
<span class="sd">        :param L_Obj: Liste de coordonnées de points de l&#39;objet</span>
<span class="sd">        :type L_Obj: List </span>
<span class="sd">        </span>
<span class="sd">        :param L_Bkg: Liste de coordonnées de points de l&#39;arrière-plan</span>
<span class="sd">        :type L_Bkg: List</span>
<span class="sd">        </span>
<span class="sd">        :param gamma: Liste élément structurant</span>
<span class="sd">        :type gamma: List</span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Partage_eaux</span>
<span class="sd">        :rtype: Partage_eaux</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.largeur largeur de l&#39;image</span>
<span class="sd">        * self.hauteur hauteur de l&#39;image</span>
<span class="sd">        </span>
<span class="sd">        * self.tab_gradient image du gradient</span>
<span class="sd">        * self.tab_objet image des objets </span>
<span class="sd">        * self.tab_bkg image de l&#39;arrière plan</span>
<span class="sd">        * self.Liste_Pixels_Objet liste de tous les pixels objet détectés</span>

<span class="sd">        </span>
<span class="sd">        Pour les lignes et les colonnes je me place du point de vue de l&#39;image. </span>
<span class="sd">        Dans le tableau numpy, les coordonnées sont inversées.</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">largeur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">hauteur</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">image</span><span class="o">=</span><span class="n">image</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">gradient</span> <span class="o">=</span> <span class="n">Gradient</span><span class="p">(</span><span class="n">image</span><span class="p">,</span><span class="n">gamma</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">L_objet</span> <span class="o">=</span> <span class="n">L_Obj</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">L_bkg</span> <span class="o">=</span> <span class="n">L_Bkg</span></div>


   <span class="c1">## FONCTIONS POUR L&#39;ALGORITHME DE PARTAGE DES EAUX </span>
    
<div class="viewcode-block" id="Partage_eaux.initialise_liste_depuis_marqueurs"><a class="viewcode-back" href="../tec_doc.html#Partage_eaux.Partage_eaux.initialise_liste_depuis_marqueurs">[docs]</a>    <span class="k">def</span> <span class="nf">initialise_liste_depuis_marqueurs</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Initialise la liste triée des pixels pour l&#39;algorithme de partage des eaux.</span>

<span class="sd">        :param self: Objet Partage_eaux </span>
<span class="sd">        :type self: Objet Partage_eaux</span>
<span class="sd">        </span>
<span class="sd">        :return: list_triee_pixel liste triée des pixels contenant les pixels de l&#39;objet self.gradient correspondants aux points sélectionnés sur l&#39;image.</span>
<span class="sd">        :rtype: objet ListeTrieePixel</span>

<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># initialisation de la liste triée</span>
        <span class="n">list_triee_pixel</span><span class="o">=</span><span class="n">ListeTrieePixel</span><span class="p">()</span>
        <span class="c1"># mise à jour et ajout à la liste triée des pixels background - champ zone à 0</span>
        <span class="k">for</span> <span class="n">coord</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">L_bkg</span><span class="p">:</span>
            <span class="n">pix</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gradient</span><span class="o">.</span><span class="n">tab</span><span class="p">[</span><span class="n">coord</span><span class="p">[</span><span class="mi">0</span><span class="p">]][</span><span class="n">coord</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span>
            <span class="n">pix</span><span class="o">.</span><span class="n">maj_zone</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="n">list_triee_pixel</span><span class="o">.</span><span class="n">insere_pixel</span><span class="p">(</span><span class="n">pix</span><span class="p">)</span>
        <span class="c1"># mise à jour et ajout à la liste triée des pixels objets - champ zone à 1   </span>
        <span class="k">for</span> <span class="n">coord</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">L_objet</span><span class="p">:</span>
            <span class="n">pix</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gradient</span><span class="o">.</span><span class="n">tab</span><span class="p">[</span><span class="n">coord</span><span class="p">[</span><span class="mi">0</span><span class="p">]][</span><span class="n">coord</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span>
            <span class="n">pix</span><span class="o">.</span><span class="n">maj_zone</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
            <span class="n">list_triee_pixel</span><span class="o">.</span><span class="n">insere_pixel</span><span class="p">(</span><span class="n">pix</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">list_triee_pixel</span></div>
    
    
<div class="viewcode-block" id="Partage_eaux.partage"><a class="viewcode-back" href="../tec_doc.html#Partage_eaux.Partage_eaux.partage">[docs]</a>    <span class="k">def</span> <span class="nf">partage</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Procédure de mise en oeuvre de l&#39;algorithme de partage des eaux. </span>
<span class="sd">        Mise à jour du champ zone de tous les pixels dans l&#39;objet self.gradient</span>

<span class="sd">        :param self: Objet Partage_eaux </span>
<span class="sd">        :type self: Objet Partage_eaux</span>
<span class="sd">        </span>
<span class="sd">        :return: None</span>
<span class="sd">        :rtype: None</span>

<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1"># initialisation</span>
        <span class="n">liste_triee_pixel</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">initialise_liste_depuis_marqueurs</span><span class="p">()</span> 

        <span class="c1"># inondation</span>
        <span class="k">while</span> <span class="ow">not</span> <span class="n">liste_triee_pixel</span><span class="o">.</span><span class="n">est_vide</span><span class="p">():</span>
            <span class="nb">min</span><span class="o">=</span><span class="n">liste_triee_pixel</span><span class="o">.</span><span class="n">pop_pixel</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="n">liste_voisins_de_min</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gradient</span><span class="o">.</span><span class="n">calcule_liste_pixels_voisins_depuis_pixel</span><span class="p">(</span><span class="nb">min</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">pixel</span> <span class="ow">in</span> <span class="n">liste_voisins_de_min</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">pixel</span><span class="o">.</span><span class="n">zone</span><span class="o">==-</span><span class="mi">1</span><span class="p">:</span>
                    <span class="n">pixel</span><span class="o">.</span><span class="n">maj_zone</span><span class="p">(</span><span class="nb">min</span><span class="o">.</span><span class="n">zone</span><span class="p">)</span>
                    <span class="n">liste_triee_pixel</span><span class="o">.</span><span class="n">insere_pixel</span><span class="p">(</span><span class="n">pixel</span><span class="p">)</span></div>

                    
<div class="viewcode-block" id="Partage_eaux.extrait_liste_coordonnees_des_pixels_de_zone"><a class="viewcode-back" href="../tec_doc.html#Partage_eaux.Partage_eaux.extrait_liste_coordonnees_des_pixels_de_zone">[docs]</a>    <span class="k">def</span> <span class="nf">extrait_liste_coordonnees_des_pixels_de_zone</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">zone</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Extrait de l&#39;objet self.gradient la liste des pixels de la zone identifiée par zone.</span>

<span class="sd">        :param self: Objet Partage_eaux </span>
<span class="sd">        :type self: Objet Partage_eaux</span>
<span class="sd">        </span>
<span class="sd">        :param zone: identifiant de la zone dont on veut extraire les coordonnées des pixels </span>
<span class="sd">        :type zone: int</span>
<span class="sd">        </span>
<span class="sd">        :return: Liste des coordonnées de tous les pixels de l&#39;objet identifié par l&#39;entier zone</span>
<span class="sd">        :rtype: List</span>

<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">liste_coord</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">ligne</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">gradient</span><span class="o">.</span><span class="n">tab</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">pixel</span> <span class="ow">in</span> <span class="n">ligne</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">pixel</span><span class="o">.</span><span class="n">zone</span><span class="o">==</span><span class="n">zone</span><span class="p">:</span>
                    <span class="n">liste_coord</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">pixel</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">pixel</span><span class="o">.</span><span class="n">y</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">liste_coord</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>